#!/usr/bin/perl
# add.cgi
# Add or update a server or group from the webmin servers module

require './cluster-useradmin-lib.pl';
&ReadParse();
@servers = &list_servers();

if ($in{'add'}) {
	# Add a single host
	@add = grep { $_->{'id'} eq $in{'server'} } @servers;
	&error_setup($text{'add_err'});
	}
else {
	# Add all from a group
	@add = grep { $_->{'group'} eq $in{'group'} } @servers;
	&error_setup($text{'add_gerr'});
	}

# Get the users and groups for each host
&foreign_require("useradmin", "user-lib.pl");
$pft = &foreign_call("useradmin", "passfiles_type");
$gft = &foreign_call("useradmin", "groupfiles_type");
foreach $s (@add) {
	local $host = { 'id' => $s->{'id'} };
	&remote_foreign_check($s->{'host'}, "useradmin") ||
		&error(&text('add_echeck', $s->{'host'}));
	&remote_foreign_require($s->{'host'}, "useradmin", "user-lib.pl");

	local $rpft = &remote_foreign_call($s->{'host'}, "useradmin",
					   "passfiles_type");
	&error(&text('add_epft', $s->{'host'})) if ($pft != $rpft);
	#local $rgft = &remote_foreign_call($s->{'host'}, "useradmin",
	#				   "groupfiles_type");
	#&error(&text('add_egft', $s->{'host'})) if ($gft != $rgft);

	local @rusers = &remote_foreign_call($s->{'host'}, "useradmin",
					     "list_users");
	local @rgroups = &remote_foreign_call($s->{'host'}, "useradmin",
					      "list_groups");
	$host->{'users'} = \@rusers;
	$host->{'groups'} = \@rgroups;
	&save_useradmin_host($host);
	}
&remote_finished();
&redirect("");

