# frontpage-lib.pl
# functions for admin of frontpage websites

do '../web-lib.pl';
&init_config();

##########################################################################
# fp_install(vhost, admuser, passwd, httpd_conf)
# install the frontpage extenstions to a new vhost with a user and password

sub fp_install
{
	my ($vhost, $admuser, $passwd);

	$vhost		= $_[0];
	$admuser		= $_[1];
	$passwd		= $_[2];

	# create the command
	$cmd = "$config{'fpsrvadm'} -o install -t apache-fp " .
	       "-s $config{'httpd_conf'} -p 80 " .
	       "-m $vhost -u $admuser -pw $passwd -xu nobody -xg nobody";
	return `$cmd 2>&1`;
}

#########################################################################
# fp_mod_user (vhost, level, user, passwd)
# adds/modifies a user of the fp web

sub fp_mod_user
{
	my ($cmd, $vhost, $user, $level, $passwd);
	$vhost	= $_[0];
	$level	= $_[1];
	$user		= $_[2];
	$passwd	= $_[3];
 
	$cmd = "$config{'fpsrvadm'} -o security -s $config{'httpd_conf'} -m $vhost " .
	       "-access $level -u $user -p 80 -w '' ";
	if ($passwd ne ""){
		$cmd .= "-pw $passwd";
	}
	return `$cmd 2>&1`;
	# return $cmd;
}

#########################################################################
# fp_delete_user (vhost, user)
# deletes a user's access to the web

sub fp_delete_user
{
	my ($cmd, $vhost, $user);
	$vhost	= $_[0];
	$user		= $_[1];

	$cmd = "$config{'fpsrvadm'} -o security -access 'remove' -p 80 -w '' " .
	       "-m $vhost -u $user";
	return `$cmd 2>&1`;
	# return $cmd;
}

#########################################################################
# fp_list_access(vhost)
# lists the users and level's of access they have for a vhost

sub fp_list_access
{
	local ($cmd, $vhost, $vconf, $v, $idx);
	$vhost	= $_[0];
	
	&foreign_require('apache', 'apache-lib.pl');
	($vconf, $v) = &foreign_call('apache', 'get_virtual_config', $vhost);
	
	for($idx=0; $idx<@$vconf; $idx++) {
		local $d = $vconf->[$idx];
		print "$idx ==> $d->{'name'}\n";
	}
	
	return $vhost;
}

#########################################################################
# fp_defaults
# create the initial defualts
sub fp_defaults
{
	%vars = ('httpd_conf' => '/usr/local/apache/conf/httpd.conf',
	         'fpsrvadm'   => '/usr/local/frontpage/version4.0/bin/fpsrvadm.exe');
	%apache_mod = &foreign_config('apache');
	if ($apache_mod{'httpd_conf'} ne ''){
		$vars{'httpd_conf'} = $apache_mod{'httpd_conf'};
	}
	$config_file = $module_config_directory . "/config";
	&write_file($config_file, \%vars);
}
