#!/usr/bin/perl
# save_user.cgi
# Saves or creates a new user. If the changes require moving of the user's
# home directory or changing file ownerships, do that as well

use POSIX;

require './user-lib.pl';
require 'timelocal.pl';
$whatfailed = "Failed to save user";
&ReadParse;
%access = &get_module_acl();

#LDAP Headers
use Getopt::Std;			# To parse command line arguments.
use Mozilla::LDAP::Conn;		# Main "OO" layer for LDAP
use Mozilla::LDAP::Utils;		# LULU, utilities.
	
use strict;
no strict "vars";

$serverLDAP = "127.0.0.1";
$portLDAP = "389";
$base = "o=ServerName, c=com";


$uid = $in{'uid'};

$cn_old = $in{'cn_old'};
$cn = $in{'cn'};
$mail = $in{'mail'};
$o = $in{'o'};
$giveName = $in{'giveName'};
$sn = $in{'sn'};
$HomeCellular = $in{'HomeCellular'};
$streetAddress = $in{'streetAddress'};
$st = $in{'st'};
$postalCode = $in{'postalCode'};
$department = $in{'department'};
$officelocation = $in{'officelocation'};
$telephoneNumber = $in{'telephoneNumber'};
$officeFax = $in{'officeFax'};
$officewebpage = $in{'officewebpage'};
$description = $in{'description'};
$title = $in{'title'};

if (! $in{'cn'}) {
 &error("Common Name can't be Empty");
}

if (! $in{'mail'}) {
 &error("mail can't be Empty");
}


&header("Create User", "images/create_user.gif", "create_user");

if (! $in{'uid'}) {
 # Create random uid
 $number = ceil (rand(1000000));

   $conn = new Mozilla::LDAP::Conn($serverLDAP, $portLDAP, "cn=Manager, o=ServerName, c=com", "secret");
   die "Could't connect to LDAP server \"127.0.0.1\"" unless $conn;

    $entry = new Mozilla::LDAP::Entry();
    $entry->setDN("uid=$number,o=ServerName,c=com");
#    $entry->{objectclass} = [ "top", "person", "$cn" ];
#cn=$cn,
    $entry->addValue("cn", "$cn");
    $entry->addValue("sn", "$cn");
    $entry->addValue("mail", "$mail");
    $entry->addValue("o", "$o");
    $entry->addValue("title", "$title");
    $entry->addValue("uid", $number);
    $entry->addValue("giveName", "$giveName");
    $entry->addValue("sn", "$sn");
    $entry->addValue("HomeCellular", "$HomeCellular");
    $entry->addValue("streetAddress", "$streetAddress");
    $entry->addValue("st", "$st");
    $entry->addValue("postalCode", "$postalCode");
    $entry->addValue("department", "$department");
    $entry->addValue("officelocation", "$officelocation");
    $entry->addValue("telephoneNumber", "$telephoneNumber");
    $entry->addValue("officeFax", "$officeFax");
    $entry->addValue("officewebpage", "$officewebpage");
    $entry->addValue("description", "$description");

    $conn->add($entry);

     $conn->printError() if $conn->getErrorCode();

     if (! $conn->getErrorCode()) {
	print "<BR><BR>Il record e' stato salvato.<BR>";
     }

   $conn->close if $conn;

} else {

   $conn = new Mozilla::LDAP::Conn($serverLDAP, $portLDAP, "cn=Manager, o=ServerName, c=com", "secret");
   die "Could't connect to LDAP server \"127.0.0.1\"" unless $conn;

#print "uid = $uid";

    $entry = new Mozilla::LDAP::Entry();
    $entry->setDN("uid=$uid,o=ServerName,c=com");
#     $conn->printError() if $conn->getErrorCode();

#    $entry->{objectclass} = [ "top", "person", "$uid" ];
#    $conn->printError() if $conn->getErrorCode();

     $changed = $entry->setValue("cn", $cn);
     $changed = $entry->setValue("mail", $mail);
     $changed = $entry->setValue("o", $o);
     $changed = $entry->setValue("title", $title);
     $changed = $entry->setValue("giveName", $giveName);
     $changed = $entry->setValue("sn", $sn);
     $changed = $entry->setValue("HomeCellular", $HomeCellular);
     $changed = $entry->setValue("streetAddress", $streetAddress);
     $changed = $entry->setValue("st", $st);
     $changed = $entry->setValue("postalCode", $postalCode);
     $changed = $entry->setValue("department", $department);
     $changed = $entry->setValue("officelocation", $officelocation);
     $changed = $entry->setValue("telephoneNumber", $telephoneNumber);
     $changed = $entry->setValue("officeFax", $officeFax);
     $changed = $entry->setValue("officewebpage", $officewebpage);
     $changed = $entry->setValue("description", $description);
     $conn->printError() if $conn->getErrorCode();

     $conn->update($entry);
     $conn->printError() if $conn->getErrorCode();

     if (! $conn->getErrorCode()) {
	print "<BR><BR>Il record e' stato salvato.<BR>";
     }

   $conn->close if $conn;

}

@ulist = &list_users();

# Bounce back to the list

print "<BR><BR>";

&footer("/ldap/", "Module Index");
