#!/usr/bin/perl
# generate navbar dynamically from tabs and modules.

require './web-lib.pl';
&init_config();

print "Content-type: text/html\n\n";

&read_acl(\%acl);
opendir(DIR, ".");
$user = $ENV{'REMOTE_USER'};
$risk = $gconfig{'risk_'.$user};
foreach $d (readdir(DIR)) {
        local %minfo;
        if ($d !~ /^config-/ && (%minfo = &get_module_info($d))) {
                if (!&check_os_support(\%minfo)) {
                        # This OS is not supported!
                        next;
                        }
                if ($risk) {
                        # Check module risk level
                        next if ($risk ne 'high' && $minfo{'risk'} &&
                                 $minfo{'risk'} !~ /$risk/);
                        }
                else {
                        # Check specific ACL
                        next if (!$acl{$user,$d} && !$acl{$user,"*"});
                        }
                push(@modules, \%minfo);
                }
        }
  closedir(DIR);

  @modules = sort { $a->{'desc'} cmp $b->{'desc'} } @modules;

  &read_file("$config_directory/webmin.catnames", \%catnames);
  foreach $m (@modules) {
    $c = $m->{'category'};
    next if ($cats{$c});
    if ($catnames{$c}) {
      $cats{$c} = $catnames{$c};
    } elsif ($text{"category_$c"}) {
      $cats{$c} = $text{"category_$c"};
    } else {
      # try to get category name from module ..
      local %mtext = &load_language($m->{'dir'});
      if ($mtext{"category_$c"}) {
        $cats{$c} = $mtext{"category_$c"};
      } else {
        $c = $m->{'category'} = "";
        $cats{$c} = $text{"category_$c"};
      }
    }
  }
  @cats = sort { $b cmp $a } keys %cats;
  $cats = @cats;
  $per = $cats ? 100.0 / $cats : 100;

$hostname=&get_system_hostname();

print <<EOM;

fontsize = (navigator.platform == "Win32") ? "8pt" : "10pt";


myNavBar = new NavBar(0);
myNavBar.setSizes(1, 2, 1);
myNavBar.setColors("#0f169b",
                   "#28b3fb", "#0f169b", "#0f169b", "#28b3fb",
                   "#000000", "#cccccc", "#ffffff", "#0d20e8");
myNavBar.setFonts("Arial, Helvetica", "plain", "bold", fontsize,
                  "Arial, Helvetica", "plain", "bold", fontsize);


menu = new NavBarMenu(80, 100);
menu.addItem(new NavBarMenuItem("<CENTER><IMG SRC=/images/n.nav.gif BORDER=0></CENTER>", "http://www.niemueller.de", 0));
myNavBar.addMenu(menu);
menu = new NavBarMenu(80, 100);
menu.addItem(new NavBarMenuItem("Home", "http://$hostname"));
myNavBar.addMenu(menu);
EOM

foreach $c (@cats) {
  print "menu = new NavBarMenu(80, 150);\n";
  print "menu.addItem(new NavBarMenuItem(\"$cats{$c}\", \"\"));\n";
   foreach $m (@modules) {
	next if ($m->{'category'} ne $c);
	print "menu.addItem(new NavBarMenuItem(\"$m->{'desc'}\", \"/$m->{'dir'}\"));\n";
   }
  print "myNavBar.addMenu(menu);\n";
}

print <<EOM;

function init() {
 myNavBar.resize(getWindowWidth());
 myNavBar.create();
 myNavBar.setAlign("left");
}

function NavUpdate(){
  var viewTop,viewBottom;
  var dy;
  
  viewTop=getPageScrollY();
  viewBottom=viewTop+getWindowHeight();

  if (myNavBar.bottom<viewTop) myNavBar.moveTo(0,viewTop-myNavBar.height);

  if (myNavBar.top>viewBottom) myNavBar.moveTo(0,viewBottom);
  dy=Math.round(Math.abs(viewTop-myNavBar.y)/2);
  if (viewTop<myNavBar.y) dy=-dy;
  myNavBar.moveBy(0,dy);
  
  setTimeout('NavUpdate()',25);
}

EOM
