#!/usr/bin/perl
#
# $Id: backend_save.cgi,v 1.4 2000/12/18 09:03:27 seb Exp $
# This script does the most of saving for backends
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
require './parse_slapd_conf.pl';

my @backends = parse_slapd_conf( $config{slapd_conf_file} );
my %acls = get_module_acl();

if( $in{save} ){
    foreach my $option ( keys %in ){
	if( defined $conf_options{$backends[$in{b}]{type}}{$option} ){
	    $backends[$in{b}]{$option} = $in{$option};
	    delete $backends[$in{b}]{$option} if $in{$option} eq '';
	}
    }
    write_slapd_conf( $config{slapd_conf_file}, \@backends );
    redirect( 'index.cgi' );
}

if( $in{delete} ){
    error_setup( $text{backend_delete_error} );
    error( $text{backend_delete_access} ) unless $acls{manage};
    header( $text{'index_title'}, undef, undef, 1, undef, undef, $text{'index_right'} );
    print "<hr><b>$text{delete_confirm} \"$backends[$in{b}]{suffix}\" ?</b>\n";
    print "<form action=backend_delete.cgi method=post>\n";
    print "<input type=hidden name=b value=$in{b}>\n";
    print "<input type=submit name=yes value=$text{yes}>\n";
    print "<input type=submit name=no value=$text{no}>\n";
    print "</form><hr>\n";
    footer( "backend.cgi?b=$in{b}", $text{delete_back} );
}

if( $in{add} ){
    error_setup( $text{backend_add_error} );
    error( $text{backend_add_access} ) unless $acls{manage};
    my $b = add_backend( $config{slapd_conf_file}, $in{type}, $in{suffix} );
    redirect( "backend.cgi?b=$b" );
}
