#!/usr/bin/perl
#
# $Id: oc.cgi,v 1.7 2000/12/17 19:52:30 seb Exp $
# Main screen for editing object classes
#
#    OpenLDAP Webmin Module
#    Copyright (C) 2000 by S. Namche <snameche@virtual-net.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#

require './openldap-lib.pl';
my ($file, $type, $suffix, $backends) = get_backends( $in{b}, $in{i} );
my $cbackend = $backends->[$in{b}];

error_setup( $text{oc_save_error} );
error( $text{backend_denied} ) unless can_edit_backend( $in{b}, $in{i} );

print_header( $text{oc_title}, $file, $type, $suffix );

print "<table width=100% border><tr $tb><td><b>$text{oc_title_table}</b></td></tr>\n";
print "<tr $cb><td><table width=100%><tr>\n";

my $i = 1;
foreach $oc ( sort keys %{$cbackend->{objectclass}} ){
    print "<td><a href=\"oc_edit.cgi?b=$in{b}&i=$in{i}&oc=$oc\">$oc</a></td>\n";
    print "</tr><tr>" if $i++%3 == 0;
}

print "</tr></table></td></tr></table><br>\n";

print "<hr><h3>$text{oc_add_title}</h3>\n";
print "<form action=oc_save.cgi method=post>\n";
print "<input type=hidden name=b value=$in{b}>\n";
print "<input type=hidden name=i value=$in{i}>\n";
print "<input name=oc>&nbsp;&nbsp;<input type=submit name=add_oc value=$text{oc_add}>\n";
print "</form><hr>\n";

if( $in{i} ){
    footer( "include_edit.cgi?b=$in{b}&i=$in{i}", $text{oc_back} );
}
else {
    footer( $in{b} ? "backend.cgi?b=$in{b}" : "index.cgi", $text{oc_back} );
}
