#!/usr/bin/perl
# /nav.cgi
# Theme "gehrigal"
# Autor: Alexander Gehrig
# Email: webmin@gehrigal.de
# Internet: http://www.gehrigal.de

# version 0.16a

# Diese Version ist ready fuer den Gehrigal Themeconfigurator

require 'web-lib.pl';
require 'theme_gehrigal/theme-lib.pl';
&init_theme2();


# ****************
# Ende Themeconfig


&init_config();
$hostname = &get_system_hostname();
$ver = &get_webmin_version();
if ($gconfig{'real_os_type'}) {
	$ostr = "$gconfig{'real_os_type'} $gconfig{'real_os_version'}";
	}
else {
	$ostr = "$gconfig{'os_type'} $gconfig{'os_version'}";
	}

# Erzeugen einer Liste mit allen Modulen
&read_acl(\%acl);
opendir(DIR, ".");
$user = $ENV{'REMOTE_USER'};
$risk = $gconfig{'risk_'.$user};
foreach $d (readdir(DIR)) {
	local %minfo;
	if ($d !~ /^config-/ && (%minfo = &get_module_info($d))) {
		if (!&check_os_support(\%minfo)) {
			# This OS is not supported!
			next;
			}
		if ($risk) {
			# Check module risk level
			next if ($risk ne 'high' && $minfo{'risk'} &&
				 $minfo{'risk'} !~ /$risk/);
			}
		else {
			# Check specific ACL
			next if (!$acl{$user,$d} && !$acl{$user,"*"});
			}
		push(@modules, \%minfo);
		}
	}
closedir(DIR);
@modules = sort { $a->{'desc'} cmp $b->{'desc'} } @modules;

# Schauen nach dem aktuellen Hauptmenpunkt und welche Hauptmens eigentlich zur Verfgung stehn
&ReadParse();
foreach $m (@modules) {
	$c = $m->{'category'};
	next if ($cats{$c});
	if ($text{"category_$c"}) {
		$cats{$c} = $text{"category_$c"};
		}
	else {
		# try to get category name from module ..
		local %mtext = &load_language($m->{'dir'});
		if ($mtext{"category_$c"}) {
			$cats{$c} = $mtext{"category_$c"};
			}
		else {
			$c = $m->{'category'} = "";
			$cats{$c} = $text{"category_$c"};
			}
		}
	}
@cats = sort { $b cmp $a } keys %cats;
$cats = @cats;
$per = $cats ? 100.0 / $cats : 100;
if (!defined($in{'cat'})) {
	# Use default category
	if (defined($gconfig{'deftab'})) {
		$in{'cat'} = $gconfig{'deftab'};
		}
	else {
		$in{'cat'} = $cats[0];
		}
	}
elsif (!$cats{$in{'cat'}}) {
	$in{'cat'} = "";
	}

# Pruefen ob CSS verwendet werden soll

if( $ncm ne ''){$cssfile="<link href=\"$ncm\" rel=\"stylesheet\" type=\"text/css\" />";} else {$cssfile='';}

# Anzeigen lassen des Hauptmens
&PrintHeader();
print <<EOF;
<!doctype html public \"-//W3C//DTD HTML 3.2 Final//EN\">
<HTML>
<HEAD>
$cssfile 
</HEAD>
EOF
 
print "<BODY background='$nbg'  bgcolor=$nbc LINK=$nlc VLINK=$nvlc ALINK=$nalc topmargin=0 leftmargin=0 marginhight=0 marginwidth=0>\n";
print " <a target=_blank href=$nhtp> <IMG BORDER=0 SRC=$nl width=200 height=60 ></a><br><br>\n";
print "$mst\n";
print "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=2 WIDTH=100% HEIGHT=1>\n";
    
  
  
foreach $c (@cats) {
	if ($in{'cat'} eq $c) {
		print "<TR><TD bgcolor=$namc><b><FONT color=$namf> $cats{$c}</b></TD></TR>\n";
		
# Anzeigen lassen aller Module in dieser Kategorie
$pos = 0;
foreach $m (@modules) {
	next if ($m->{'category'} ne $in{'cat'});
	print "<TR><TD WIDTH=100% nowrap bgcolor=$nsc><A TARGET=Hauptframe HREF=/$m->{'dir'}/ ><FONT color=$nsfc><li> $m->{'desc'} </li></FONT></A></TD></tr>\n";
		}



}
	else {
		print "<TR><TD bgcolor=$nmmc><b><A TARGET=Inhalt HREF='nav.cgi?cat=$c'><FONT color=$nmmf> $cats{$c}</A></b></TD></TR>\n";
		}
	}


print <<EOF;
</TABLE>	    
<br>
<br><FONT color=$nfc><b>
EOF
if ($main::session_id)	{
            		print "<p align=right><a href='session_login.cgi?logout=1' target=\"_top\">",
		        "$text{'main_logout'}</a></p>\n";
			}
else 			{
			print "<p align=right><a href=switch_user.cgi target=\"_top\">",
			"$text{'main_switch'}</a></p>\n";
			}
print <<EOF;
</b><hr width="100%" color="$nhr">
<i><b>Admin: </b><a href="mailto:$nam">$nan</a>
<br><br>
<hr width="100%" color="$nhr">
<a onClick='window.open("themeinfo.cgi", "Themeinfo", "toolbar=no,menubar=no,scrollbars=yes,width=500,height=450,resizable=yes"); return false' href="themeinfo.cgi">Themeinfo</a>
</i></FONT>
</BODY>
</HTML>
EOF

