#!/usr/bin/perl
# start3.cgi
# Theme "gehrigal"
# Autor: Alexander Gehrig
# Email: webmin@gehrigal.de
# Internet: http://www.gehrigal.de

# version 0.16a

# Diese Version ist ready fuer den Gehrigal Themeconfigurator

require 'web-lib.pl';
&init_config();
require 'theme_gehrigal/theme-lib.pl';
&init_theme2();


# ****************
# Ende Themeconfig
#

#****************************
#
&init_config();
$hostname = &get_system_hostname();
$ver = &get_webmin_version();
if ($gconfig{'real_os_type'}) {
	$ostr = "$gconfig{'real_os_type'} $gconfig{'real_os_version'}";
	}
else {
	$ostr = "$gconfig{'os_type'} $gconfig{'os_version'}";
	}



local $smart_user = $ENV{'REMOTE_USER'};
local $smart_ip = $ENV{'REMOTE_ADDR'};
local $smart_time = localtime();



# Erzeugen einer Liste mit allen Modulen
&read_acl(\%acl);
opendir(DIR, ".");
$user = $ENV{'REMOTE_USER'};
$risk = $gconfig{'risk_'.$user};
foreach $d (readdir(DIR)) {
	local %minfo;
	if ($d !~ /^config-/ && (%minfo = &get_module_info($d))) {
		if (!&check_os_support(\%minfo)) {
			# This OS is not supported!
			next;
			}
		if ($risk) {
			# Check module risk level
			next if ($risk ne 'high' && $minfo{'risk'} &&
				 $minfo{'risk'} !~ /$risk/);
			}
		else {
			# Check specific ACL
			next if (!$acl{$user,$d} && !$acl{$user,"*"});
			}
		push(@modules, \%minfo);
		}
	}
closedir(DIR);
@modules = sort { $a->{'desc'} cmp $b->{'desc'} } @modules;

# Schauen nach dem aktuellen Hauptmenpunkt und welche Hauptmens eigentlich zur Verfgung stehn
&ReadParse();
foreach $m (@modules) {
	$c = $m->{'category'};
	next if ($cats{$c});
	if ($text{"category_$c"}) {
		$cats{$c} = $text{"category_$c"};
		}
	else {
		# try to get category name from module ..
		local %mtext = &load_language($m->{'dir'});
		if ($mtext{"category_$c"}) {
			$cats{$c} = $mtext{"category_$c"};
			}
		else {
			$c = $m->{'category'} = "";
			$cats{$c} = $text{"category_$c"};
			}
		}
	}
@cats = sort { $b cmp $a } keys %cats;
$cats = @cats;
$per = $cats ? 100.0 / $cats : 100;
if (!defined($in{'cat'})) {
	# Use default category
	if (defined($gconfig{'deftab'})) {
		$in{'cat'} = $gconfig{'deftab'};
		}
	else {
		$in{'cat'} = $cats[0];
		}
	}
elsif (!$cats{$in{'cat'}}) {
	$in{'cat'} = "";
	}


#*********************************************
# Ausgabe von HTML

&header("Smart Start: $hostname","",undef,0,1);
print <<EOF;
<hr>
<blockquote>
<TABLE border="0" width="80%" cellspacing="0" cellpadding="0" $cb>
EOF
     

foreach $c (@cats) {
print "<tr $tb align=\"center\"><td colspan=\"3\"><b>$cats{$c}</b> </td></tr>\n";


$pos = 0;
$cols = $gconfig{'nocols'} ? $gconfig{'nocols'} : 3;
$per = 100.0 / $cols;
foreach $m (@modules) {
			next if ($m->{'category'} ne $c);
					
			if ($pos % $cols == 0) { print "<tr $cb>\n"; }
			print "<TD ><img src=$m->{'dir'}/images/icon.gif alt=\"\" border=0 width=\"24\" height=\"24\"></a><A TARGET=Hauptframe HREF=/$m->{'dir'}/ >$m->{'desc'}</A></TD>\n";
			if ($pos++ % $cols == $cols - 1) { print "</tr>\n"; }
			}
		}
print <<EOF;
</table>
<br>
<Table border="0">
<tr>
<td $tb colspan="2"><b>Systeminformation</b></td>
<td $tb colspan="2"><b>Userinfo</b></td>
</tr>
<tr>
<td $cb><b>OS:</b></td>
<td $cb>$ostr</td>
<td $cb><b>User:</b></td>
<td $cb>$smart_user</td>
</tr>
<tr>
<td $cb><b>Webminversion:</b></td>
<td $cb>$ver</td>
<td $cb><b>Remote IP:</b></td>
<td $cb>$smart_ip</td>
</tr>
<tr>
<td $cb><b>Hostname:</b></td>
<td $cb>$hostname</td>
</tr>
<tr>
<td $cb><b>Time:</b></td>
<td $cb>$smart_time</td>
</tr>
</table>

</blockquote>
<hr>
</BODY>
</HTML>
EOF

